/*
 @C:\WEB_EVOL\Sql\Oracle\5099_DFESTP_ARREDONDA_BASECALC.SQL

 Descrio:
 Procedure para arredondar o valor da base de clculo de acordo com o valor contabil

 Criao:
 02/06/05 - Cristiane Faria dos Santos
*/

CREATE OR REPLACE PROCEDURE ARREDONDA_BASECALC(
	P_IDENTRSAID  IN NOTAFISCAL.IDENTRSAIDOP%TYPE,
   P_FILIAL      IN VARCHAR2,
   P_LANCTONF    IN VARCHAR2)

IS

   V_VRDIFERENCA   NUMBER;
   V_VRCONTIMPOIT  NUMBER;
   V_VRBCALCIMPOIT NUMBER;
   V_VRBASECALCIT  NUMBER;
   w_1             CHAR(1):= '1';
BEGIN

   IF P_IDENTRSAID = 'E' THEN
      FOR C_ITEMPRODUTO IN (SELECT T.CDIMPOSTOIT AS CDIMPOSTO, I.NRSEQITPROD,
                                   MAX(NVL(VRCONTIMPOIT,0)) AS VRCONTIMPOIT
                            FROM ITEMPRODUTO I, TRABITPROIMPOS T
                            WHERE CDFILIAL     = P_FILIAL      AND
                                  NRLANCTONF   = P_LANCTONF    AND
                                  CDFILIMPOIT  = I.CDFILIAL    AND
                                  NRLANCIMPOIT = I.NRLANCTONF  AND
                                  NRSEQIMPOIT  = I.NRSEQITPROD AND
                                  NRSEQITPRO   = w_1
                            GROUP BY T.CDIMPOSTOIT, I.NRSEQITPROD) LOOP

         IF C_ITEMPRODUTO.VRCONTIMPOIT <> 0 THEN
            UPDATE TRABITPROIMPOS
            SET VRBCALCIMPOIT  = ROUND(VRBCALCIMPOIT,2),
                VRIMPOSIT      = ROUND(VRIMPOSIT,2)
            WHERE CDFILIMPOIT  = P_FILIAL                  AND
                  NRLANCIMPOIT = P_LANCTONF                AND
                  NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD AND
                  CDIMPOSTOIT  = C_ITEMPRODUTO.CDIMPOSTO   AND
                  NRSEQITPRO   = w_1;

            Begin
               SELECT NVL(VRBCALCIMPOIT,0)
               INTO V_VRBCALCIMPOIT
               FROM TRABITPROIMPOS
               WHERE CDFILIMPOIT  = P_FILIAL                  AND
                     NRLANCIMPOIT = P_LANCTONF                AND
                     NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD AND
                     CDIMPOSTOIT  = C_ITEMPRODUTO.CDIMPOSTO   AND
                     NRSEQITPRO   = w_1;
            Exception
               When No_Data_Found Then
                  V_VRBCALCIMPOIT  := 0;
            End;

            V_VRDIFERENCA := (C_ITEMPRODUTO.VRCONTIMPOIT - V_VRBCALCIMPOIT);

            IF (V_VRDIFERENCA <> 0) AND (ABS(V_VRDIFERENCA) < 0.03) THEN
               UPDATE TRABITPROIMPOS
               SET VRBCALCIMPOIT  = (VRBCALCIMPOIT + V_VRDIFERENCA)
               WHERE CDFILIMPOIT  = P_FILIAL                  AND
                     NRLANCIMPOIT = P_LANCTONF                AND
                     NRSEQIMPOIT  = C_ITEMPRODUTO.NRSEQITPROD AND
                     CDIMPOSTOIT  = C_ITEMPRODUTO.CDIMPOSTO   AND
                     NRSEQITPRO   = w_1;
            END IF;
         END IF;
      END LOOP;
   END IF;

   FOR C_ITEMPROIMPOS IN (SELECT T.CDIMPOSTO, I.NRSEQITPROD, MAX(NVL(VRCONTITIMP,0)) AS VRCONTITIMP
                          FROM ITEMPRODUTO I, ITEMPROIMPOS T
                          WHERE I.CDFILIAL     = P_FILIAL       AND
                                I.NRLANCTONF   = P_LANCTONF     AND
                                T.CDFILIAL     = I.CDFILIAL     AND
                                T.NRLANCTONF   = I.NRLANCTONF   AND
                                T.NRSEQITPROD  = I.NRSEQITPROD AND
                                T.NRITPROIMPOS = w_1
                          GROUP BY T.CDIMPOSTO, I.NRSEQITPROD) LOOP

      IF C_ITEMPROIMPOS.VRCONTITIMP <> 0 THEN
         UPDATE ITEMPROIMPOS
         SET VRBASECALCIT = ROUND(VRBASECALCIT,2),
             VRIMPOSTOIT  = ROUND(VRIMPOSTOIT,2)
         WHERE (NRLANCTONF   = P_LANCTONF) AND
               (CDFILIAL     = P_FILIAL)   AND
               (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD) AND
               (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)   AND
               (NRITPROIMPOS = w_1);

         Begin
            SELECT NVL(VRBASECALCIT,0)
            INTO V_VRBASECALCIT
            FROM ITEMPROIMPOS
            WHERE (NRLANCTONF   = P_LANCTONF) AND
                  (CDFILIAL     = P_FILIAL)   AND
                  (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD) AND
                  (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)   AND
                  (NRITPROIMPOS = w_1);
         Exception
            When No_Data_Found Then
               V_VRBASECALCIT  := 0;
         End;

         V_VRDIFERENCA := (C_ITEMPROIMPOS.VRCONTITIMP - V_VRBASECALCIT);

         IF (V_VRDIFERENCA <> 0) AND (ABS(V_VRDIFERENCA) < 0.03) THEN
            UPDATE ITEMPROIMPOS
            SET VRBASECALCIT  = (VRBASECALCIT + V_VRDIFERENCA)
            WHERE (NRLANCTONF   = P_LANCTONF) AND
                  (CDFILIAL     = P_FILIAL)   AND
                  (NRSEQITPROD  = C_ITEMPROIMPOS.NRSEQITPROD) AND
                  (CDIMPOSTO    = C_ITEMPROIMPOS.CDIMPOSTO)   AND
                  (NRITPROIMPOS = w_1);
         END IF;
      END IF;

   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARREDONDA_BASECALC','5.05.020'); END;
/

